/*
 * This file is part of SionTower.
 *
 * 
 * David Saltares Marquez (C) 2011
 * <david.saltares@gmail.com>
 *
 * 
 * SionTower examples are free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License ad
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) ant later version.
 *
 * SionTower examples are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SionTower examples.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef SIONTOWER_TRUNK_SRC_INCLUDE_PLAYER_H_
#define SIONTOWER_TRUNK_SRC_INCLUDE_PLAYER_H_

#include <OGRE/Ogre.h>
#include <OIS/OIS.h>

#include "gameObject.h"

class Shape;

/**
 *  @author David Saltares M&aacute;rquez
 *  @date 4-02-2011
 */
class Player: public GameObject {
    public:
        Player(Ogre::SceneManager* sceneManager, Ogre::Camera* camera, OIS::Keyboard* keyboard);
        ~Player();
        void update(Ogre::Real deltaT);

        void restoreOldPosition(); 
        const Ogre::Vector3 getOldPosition() const;
    private:
        Ogre::Camera* _camera;
        OIS::Keyboard* _keyboard;

        Ogre::Vector3 _oldPos;
        Ogre::Degree _actualAngle;
        Ogre::Degree _targetAngle;
        Ogre::Vector3 _actualDirection;
        Ogre::Vector3 _targetDirection;
        Ogre::Vector3 _velocity;
        bool _turning;
        bool _walking;
};

#endif  // SIONTOWER_TRUNK_SRC_INCLUDE_PLAYER_H_
